<?php
// Coding by SparkuS, email: by.sparkus@gmail.com
define('_IN_esCMS', 1);

define('VERSION', '1.0.0'); // Инсталлируемая версия

class install
{
    // Критические ошибки настройки PHP
	static function check_php_errors()
	{
		$error = array();
		if (version_compare(phpversion(), '5.2.0', '<')) $error[] = 'PHP '.phpversion();
		if (!extension_loaded('mysql')) $error[] = 'mysql';
		if (!extension_loaded('gd')) $error[] = 'gd';
		if (!extension_loaded('zlib')) $error[] = 'zlib';
		if (!extension_loaded('mbstring')) $error[] = 'mbstring';
		return !empty($error) ? $error : false;
	}

    // Некритические предупреждения настройки PHP
	static function check_php_warnings()
	{
		$error = array();
		if (ini_get('register_globals')) $error[] = 'register_globals';
		return !empty($error) ? $error : false;
	}

	// Проверяем права доступа к папкам
	static function check_folders_rights()
	{
		$folders = array('files/cache/', 'files/screen/', 'system/');
		$error = array();
		foreach ($folders as $val)
		{
			if (!is_writable($val))
			{
				$error[] = $val;
			}
		}
		return !empty($error) ? $error : false;
	}

	// Парсинг SQL файла
	static function parse_sql($file = false)
	{
		$errors = array();
		if ($file && file_exists($file))
		{
			$query = fread(fopen($file, 'r'), filesize($file));
			$query = trim($query);
			$query = preg_replace("/\n\#[^\n]*/", '', "\n" . $query);
			$buffer = array();
			$ret = array();
			$in_string = false;
			for ($i = 0; $i < strlen($query) - 1; $i++)
			{
				if ($query[$i] == ";" && !$in_string)
				{
					$ret[] = substr($query, 0, $i);
					$query = substr($query, $i + 1);
					$i = 0;
				}
				if ($in_string && ($query[$i] == $in_string) && $buffer[1] != "\\")
				{
					$in_string = false;
				} elseif (!$in_string && ($query[$i] == '"' || $query[$i] == "'") && (!isset($buffer[0]) || $buffer[0] != "\\"))
				{
					$in_string = $query[$i];
				}
				if (isset($buffer[1]))
				{
					$buffer[0] = $buffer[1];
				}
				$buffer[1] = $query[$i];
			}
			if (!empty($query))
			{
				$ret[] = $query;
			}
			for ($i = 0; $i < count($ret); $i++)
			{
				$ret[$i] = trim($ret[$i]);
				if (!empty($ret[$i]) && $ret[$i] != "#")
				{
					if (!mysql_query($ret[$i]))
					{
						$errors[] = mysql_error();
					}
				}
			}
		} else {
			$errors[] = 'ERROR: SQL file';
		}
		return $errors;
	}
}

function show_errors($error)
{
	if (!empty($error))
	{
		// Показываем ошибки
		$out = '<div class="red" style="margin-bottom: 4px"><b>ОШИБКА!</b>';
		foreach ($error as $val) $out .= '<div>'.$val.'</div>';
		$out .= '</div>';
		return $out;
	} else {
		return false;
	}
}

// Показываем инсталлятор
$act = isset($_REQUEST['act']) ? trim($_REQUEST['act']) : false;

if (file_exists('system/connect.php') && $act == 'final')
{
	require('system/escore.php');
} else {
	session_name('SESID');
	session_start();
}

ob_start();
echo '<!DOCTYPE html>' . "\n" .
	'<head>' . "\n" .
	'<meta charset="utf-8">' . "\n" .
	'<title>esCMS '.VERSION.'</title>' . "\n" .
	'<style type="text/css">' .
	'a, a:link, a:visited{color: blue;}' .
	'body {font-family: Arial, Helvetica, sans-serif; font-size: small; color: #000000; background-color: #FFFFFF}' .
	'h1{margin: 0; padding: 0; padding-bottom: 4px;}' .
	'h2{margin: 0; padding: 0; padding-bottom: 4px;}' .
	'h3{margin: 0; padding: 0; padding-bottom: 2px;}' .
	'ul{margin:0; padding-left:20px; }' .
	'li{padding-bottom: 6px; }' .
	'.red{color: #FF0000;}' .
	'.green{color: #009933;}' .
	'.blue{color: #0000EE;}' .
	'.gray{color: gray;}' .
	'.pgl{padding-left: 8px}' .
	'.select{color: blue; font-size: medium; font-weight: bold}' .
	'.small{font-size: x-small}' .
	'.st{color: gray; text-decoration: line-through}' .
	'</style>' . "\n" .
	'</head>' . "\n" .
	'<body>' . "\n" .
	'<h1>esCMS (catalogy) <span class="red">'.VERSION.'</span></h1><hr />';

switch ($act)
{
	case 'final':
		// Установка завершена
		echo '<span class="st">Начальная проверка</span><br />' .
			'<span class="st">База данных</span><br />' .
			'<span class="st">Настройки сайта</span>' .
			'<h2 class="green">Финиш</h2>' .
			'<hr />';
		echo '<h3 class="blue">ПОЗДРАВЛЯЕМ!</h3>' .
			'Установка успешно завершена<br />Теперь можно зайти в Админ панель и настроить свой Сайт<p><ul>' .
			'<li><a href="xpanel">Админ панель</a></li>' .
			'<li><a href="index.php">Перейти на сайт</a></li>' .
			'</ul></p>' .
			'<h3 class="red">ВНИМАНИЕ!</h3>После завершения процедуры установки необходимо:<p><ul><li>Удалить файл <b class="blue">install.php</b></li><li>Сменить права папки <b class="blue">system</b> на <b class="blue">755</b></li><li>Сменить права файла <b class="blue">system/connect.php</b> на <b class="blue">644</b></li></ul></p>';
	break;

	case 'set':
		// Создание базы данных и Администратора системы
		$db_check = false;
		$db_error = array();
		$site_error = array();
		$admin_error = array();

		// Принимаем данные формы
		$db_host = isset($_POST['dbhost']) ? htmlentities(trim($_POST['dbhost'])) : 'localhost';
		$db_name = isset($_POST['dbname']) ? htmlentities(trim($_POST['dbname'])) : 'test';
		$db_user = isset($_POST['dbuser']) ? htmlentities(trim($_POST['dbuser'])) : 'root';
		$db_pass = isset($_POST['dbpass']) ? htmlentities(trim($_POST['dbpass'])) : '';
		$site_url = isset($_POST['siteurl']) ? preg_replace("#/$#", '', htmlentities(trim($_POST['siteurl']), ENT_QUOTES, 'UTF-8')) : 'http://'.$_SERVER["SERVER_NAME"];
		$site_mail = isset($_POST['sitemail']) ? htmlentities(trim($_POST['sitemail']), ENT_QUOTES, 'UTF-8') : '@';
		$admin_user = isset($_POST['admin']) ? trim($_POST['admin']) : 'admin';
		$admin_pass = isset($_POST['password']) ? trim($_POST['password']) : '';

		// Проверяем заполнение реквизитов базы данных
		if (isset($_POST['check']) || isset($_POST['install'])){
			if (empty($db_host)) {
                $db_error['host'] = $lng['error_db_host_empty'];
            }

            if (empty($db_name)) {
                $db_error['name'] = $lng['error_db_name_empty'];
            }

            if (empty($db_user)) {
                $db_error['user'] = $lng['error_db_user_empty'];
            }

            // Проверяем подключение к серверу базы данных
            if (empty($db_error)) {
                $con_err = false;
                @mysql_connect($db_host, $db_user, $db_pass) or $con_err = mysql_error();

                if ($con_err && stristr($con_err, 'no such host')) {
                    $db_error['host'] = $lng['error_db_host'];
                } elseif ($con_err && stristr($con_err, 'access denied for user')) {
                    $db_error['access'] = $lng['error_db_user'];
                } elseif ($con_err) {
                    $db_error['unknown'] = $lng['error_db_unknown'];
                }
            }

            // Проверяем наличие базы данных
            if (empty($db_error) && @mysql_select_db($db_name) == false) {
                $db_error['name'] = $lng['error_db_name'];
            }

            if (empty($db_error)) {
                $db_check = true;
            }

            @mysql_close();
        }

        if ($db_check && isset($_POST['install'])) {
            // Проверяем URL сайта
            if (empty($site_url)) {
                $site_error['url'] = $lng['error_siteurl_empty'];
            }

            // Проверяем наличие ника Админа
            if (empty($admin_user)) {
                $admin_error['admin'] = $lng['error_admin_empty'];
            }

            // Проверяем ник Админа на длину
            if (mb_strlen($admin_user) < 2 || mb_strlen($admin_user) > 15) {
                $admin_error['admin'] = $lng['error_admin_lenght'];
            }

            // Проверяем ник Админа на допустимые символы
            if (preg_match("/[^\dA-Za-z\-\@\*\(\)\?\!\~\_\=\[\]]+/", $admin_user)) {
                $admin_error['admin'] = $lng['error_nick_symbols'];
            }

            // Проверяем пароль Админа
            if (empty($admin_pass)) {
                $admin_error['pass'] = $lng['error_password_empty'];
            }

            // Проверяем длину пароля Админа
            if (mb_strlen($admin_pass) < 5) {
                $admin_error['pass'] = $lng['error_password_lenght'];
            }

            // Проверяем пароль Админа на допустимые символы
            if (preg_match("/[^\dA-Za-z]+/", $admin_pass)) {
                $admin_error['pass'] = $lng['error_pass_symbols'];
            }

            // Если предварительные проверки прошли, заливаем базу данных
            if ($db_check && empty($site_error) && empty($admin_error)) {
                // Создаем системный файл db.php
                $dbfile = "<?php\r\n" .
                    "defined('_IN_esCMS') or die ('Restricted Access!');\r\n\r\n" .
                    "// Подключаемся к базе MySQL\r\n" .
                    '$db_host = ' . "'$db_host';\r\n" .
                    '$db_name = ' . "'$db_name';\r\n" .
                    '$db_user = ' . "'$db_user';\r\n" .
                    '$db_pass = ' . "'$db_pass';";
                if (!file_put_contents('system/connect.php', $dbfile)) {
                    echo 'ERROR: Can not write connect.php</body></html>';
                    exit;
                }

                // Соединяемся с базой данных
                $connect = mysql_connect($db_host, $db_user, $db_pass) or die('ERROR: cannot connect to DB server</body></html>');
                mysql_select_db($db_name) or die('ERROR: cannot select DB</body></html>');
                mysql_query("SET NAMES 'utf8'", $connect);

                // Заливаем базу данных
                $sql = install::parse_sql('install.sql');
                if (!empty($sql)) {
                    foreach ($sql as $val) echo $val . '<br />';
                    echo '</body></html>';
                    exit;
                }

                // Записываем системные настройки
                mysql_query("UPDATE `cms_settings` SET `set`='" . mysql_real_escape_string($site_url) . "' WHERE `name`='home'");
                mysql_query("UPDATE `cms_settings` SET `set`='" . mysql_real_escape_string($site_mail) . "' WHERE `name`='email'");

                // Создаем Администратора
                mysql_query("INSERT INTO `cms_users` SET
                    `nick` = '" . mysql_real_escape_string($admin_user) . "',
                    `login` = '" . mysql_real_escape_string(mb_strtolower($admin_user)) . "',
                    `pass` = '" . md5(md5($admin_pass)) . "',
                    `datereg` = '" . time() . "',
                    `lastdate` = '" . time() . "',
                    `rights` = '2',
                    `email` = '" . mysql_real_escape_string($site_mail) . "',
                    `ip` = '" . ip2long($_SERVER["REMOTE_ADDR"]) . "',
                    `browser` = '" . mysql_real_escape_string(htmlentities($_SERVER["HTTP_USER_AGENT"])) . "'
                ") or die('ERROR: Administrator setup<br/>' . mysql_error() . '</body></html>');
                $user_id = mysql_insert_id();

                // Устанавливаем сессию и COOKIE c данными администратора
                $_SESSION['uid'] = $user_id;
                $_SESSION['ups'] = md5(md5($admin_pass));
                setcookie("cuid", base64_encode($user_id), time() + 3600 * 24 * 365);
                setcookie("cups", md5($admin_pass), time() + 3600 * 24 * 365);

                // Установка завершена
                header('Location: install.php?act=final');
            }
        }

        echo '<span class="st">' . $lng['check_1'] . '</span>';

        if ($db_check) {
            echo '<br /><span class="st">' . $lng['database'] . '</span>' .
                '<h2 class="green">Настройки сайта</h2>';
        } else {
            echo '<h2 class="green">' . $lng['database'] . '</h2>' .
                '<span class="gray">Настройки сайта</span><br />';
        }

        echo '<span class="gray">Финиш</span>' .
            '<hr />' .
            '<form action="install.php?act=set" method="post">' .
            show_errors($db_error) .
            '<small class="blue"><b>MySQL Host:</b></small><br />' .
            '<input type="text" name="dbhost" value="' . $db_host . '"' . ($db_check ? ' readonly="readonly" style="background-color: #CCFFCC"' : '') . (isset($db_error['host']) ? ' style="background-color: #FFCCCC"' : '') . '><br />' .
            '<small class="blue"><b>MySQL Database:</b></small><br />' .
            '<input type="text" name="dbname" value="' . $db_name . '"' . ($db_check ? ' readonly="readonly" style="background-color: #CCFFCC"' : '') . (isset($db_error['name']) ? ' style="background-color: #FFCCCC"' : '') . '><br />' .
            '<small class="blue"><b>MySQL User:</b></small><br />' .
            '<input type="text" name="dbuser" value="' . $db_user . '"' . ($db_check ? ' readonly="readonly" style="background-color: #CCFFCC"' : '') . (isset($db_error['access']) || isset($db_error['user']) ? ' style="background-color: #FFCCCC"' : '') . '><br />' .
            '<small class="blue"><b>MySQL Password:</b></small><br />' .
            '<input type="text" name="dbpass" value="' . $db_pass . '"' . ($db_check ? ' readonly="readonly" style="background-color: #CCFFCC"' : '') . (isset($db_error['access']) ? ' style="background-color: #FFCCCC"' : '') . '>';

        if ($db_check) {
            // Настройки Сайта
            echo '<p>' . show_errors($site_error) .
                '<small class="blue"><b>URL сайта:</b></small><br />' .
                '<input type="text" name="siteurl" value="' . $site_url . '"' . (isset($site_error['url']) ? ' style="background-color: #FFCCCC"' : '') . '><br />' .
                '<small class="gray">Если адрес определился правильно, то не изменяйте это поле</small><br />' .
                '<small class="blue"><b>E-mail сайта:</b></small><br />' .
                '<input type="text" name="sitemail" value="' . $site_mail . '"><br />' .
                '<small class="gray">Рекомендуется указать реальный адрес<br />С него будут идти уведомления посетителям</small></p>' .
                '<p>' . show_errors($admin_error) .
                '<small class="blue"><b>Логин Администратора:</b></small><br />' .
                '<input type="text" name="admin" value="' . $admin_user . '"' . (isset($admin_error['admin']) ? ' style="background-color: #FFCCCC"' : '') . '><br />' .
                '<small class="gray">Разрешены буквы Латинского алфавита, цифры и знаки - = @ ! ? ~ _ ( ) [ ] * (кроме нуля)<br />Мин. 2, макс. 15 символов.</small><br />' .
                '<small class="blue"><b>Пароль Администратора:</b></small><br />' .
                '<input type="text" name="password" value="' . $admin_pass . '"' . (isset($admin_error['pass']) ? ' style="background-color: #FFCCCC"' : '') . '><br />' .
                '<small class="gray">Разрешены буквы Латинского алфавита и цифры<br />Мин. 5, макс. 10 символов</small></p>' .
                '<p><input type="submit" name="install" value="Установить"></p>';
        } else {
            echo '<p><input type="submit" name="check" value="Проверить"></p>';
        }

        echo '</form>';
        echo '<p><a href="install.php?act=set">Сбросить форму</a></p>';
        break;

	default:
		// Проверка настроек PHP и прав доступа
		echo '<p><h3 class="green">Добро пожаловать!</h3><ul><li>Список изменений находится в файле </li></ul></p>';
		echo '<p><h3 class="green">Начальная проверка</h3>';

		// Проверка критических ошибок PHP
		if (($php_errors = install::check_php_errors()) !== false)
		{
			echo '<h3>Критические ошибки PHP</h3><ul>';
			foreach ($php_errors as $val) echo '<li>'.$val.'</li>';
			echo '</ul>';
		}

		// Проверка предупреждений PHP
		if (($php_warnings = install::check_php_warnings()) !== false)
		{
			echo '<h3>Предупреждения PHP</h3><ul>';
			foreach ($php_warnings as $val) echo '<li>'.$val.'</li>';
			echo '</ul>';
		}

		// Проверка прав доступа к папкам
		if (($folders = install::check_folders_rights()) !== false)
		{
			echo '<h3>Права доступа 777</h3><ul>';
			foreach ($folders as $val) echo '<li>'.$val.'</li>';
			echo '</ul>';
		}

		if (!$php_errors && !$php_warnings && !$folders && !$files)
		{
			echo '<div class="pgl">Проверка настроек прошла успешно</div>';
		}
        echo '</p>';

		if ($php_errors || $folders || $files)
		{
			echo '<h3 class="red">Имеются критические ошибки.<br />Установка не может быть продолжена до их устранения.</h3>' .
				'<h3><a href="install.php">Проверить заново</a></h3>';
		} elseif ($php_warnings)
		{
			echo '<h3 class="red">Имеются предупреждения.<br />Настоятельно рекомендуется их устранить, иначе нормальная работа системы не гарантируется.</h3>' .
				'<h3><a href="install.php">Проверить заново</a></h3>' .
				'<a href="install.php?act=set">Игнорировать предупреждения и начать установку</a>';
		} else {
			echo '<form action="install.php?act=set" method="post"><p><input type="submit" value="Установка"/></p></form>';
		}
}
echo '<hr />&copy;&#160;Powered by esCMS (by.sparkus@gmail.com)</body></html>';
