<?php
defined('_IN_esCMS') or die('Error: Restricted access');

class ESFunction extends ES
{
	// Показываем дату с учетом сдвига времени (@param int $var Время в Unix формате, @return string Отформатированное время)
	public static function display_date($var){
		$shift = (self::$set['timeshift'] + self::$set['timeshift']) * 3600;
		if (date('Y', $var) == date('Y', time())){
			if (date('z', $var + $shift) == date('z', time() + $shift))
				return 'Сегодня в '.date("H:i", $var + $shift);
			if (date('z', $var + $shift) == date('z', time() + $shift) - 1)
				return 'Вчера в '.date("H:i", $var + $shift);
		}
		$search = array('January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December');
		$month = array('Января', 'Февраля', 'Марта', 'Апреля', 'Мая', 'Июня', 'Июля', 'Августа', 'Сентября', 'Октября', 'Ноября', 'Декабря');
		return str_replace($search, $month, date("d F Y в H:i", $var + $shift));
	}

	// Сообщения об ошибках (@param string|array $error Сообщение об ошибке (или массив с сообщениями), @param string $link  Необязательная ссылка перехода, @return bool|string)
	public static function display_error($error = '', $link = ''){
		if (!empty($error)){
			return '<div class="hmenu">Ошибка!</div><div class="cmenu">'.
			(is_array($error) ? implode('', $error) : $error).'<br />'.(!empty($link) ? $link : '').'</div>';
		}else{
			return FALSE;
		}
	}

	// Генератор кода
	public static function randcode($var){
		$vals = 'ABCDEFGHIJKLMNOPQRSTUWXYZabcdefghijklmnopqrstuvwxyz0123456789';
		$result = '';
		for ($i = 1; $i <= $var; $i++)
			$result .= $vals{rand(0, strlen($vals))};
		return $result;
	}

	// Антифлуд
	// Режимы работы: 1 - Адаптивный, 2 - День / Ночь, 3 - День, 4 - Ночь (@return int|bool)
	public static function antiflood(){
		$default = array('mode' => 2, 'day' => 10, 'night' => 30, 'dayfrom' => 10, 'dayto' => 22);
		$af = isset(self::$set['antiflood']) ? unserialize(self::$set['antiflood']) : $default;
		switch ($af['mode']){
			case 1:
				// Адаптивный режим
				$adm = mysql_result(mysql_query("SELECT COUNT(*) FROM `cms_users` WHERE `rights` > 0 AND `lastdate` > ".(time() - 300)), 0);
				$limit = $adm > 0 ? $af['day'] : $af['night'];
			break;
			case 3:
				// День
				$limit = $af['day'];
			break;
			case 4:
				// Ночь
				$limit = $af['night'];
			break;
			default:
				// По умолчанию день / ночь
				$c_time = date('G', time());
				$limit = $c_time > $af['day'] && $c_time < $af['night'] ? $af['day'] : $af['night'];
		}
		if (self::$user_rights > 0)
			$limit = 4; // Для Администрации задаем лимит в 4 секунды
		$flood = self::$user_data['lastpost'] + $limit - time();
		if ($flood > 0)
			return $flood;
		else
			return FALSE;
	}

	// Маскировка ссылок в тексте (@param $var, @return string)
	public static function antilink($var){
		$var = preg_replace('~\\[url=(https?://.+?)\\](.+?)\\[/url\\]|(https?://(www.)?[0-9a-z\.-]+\.[0-9a-z]{2,6}[0-9a-zA-Z/\?\.\~&amp;_=/%-:#]*)~', '###', $var);
		$replace = array(
			'.ru' => '***',
			'.com' => '***',
			'.biz' => '***',
			'.cn' => '***',
			'.in' => '***',
			'.net' => '***',
			'.org' => '***',
			'.info' => '***',
			'.mobi' => '***',
			'.wen' => '***',
			'.kmx' => '***',
			'.h2m' => '***'
		);
		return strtr($var, $replace);
	}

    // Фильтрация строк (@param string $str, @return string)
	public static function checkin($str){
		if (function_exists('iconv')){
			$str = iconv("UTF-8", "UTF-8", $str);
		}
		// Фильтруем невидимые символы
		$str = preg_replace('/[^\P{C}\n]+/u', '', $str);
		return trim($str);
	}

	// Обработка текстов перед выводом на экран
    /*
     * @param string $str
     * @param int $br   Параметр обработки переносов строк
     *                     0 - не обрабатывать (по умолчанию)
     *                     1 - обрабатывать
     *                     2 - вместо переносов строки вставляются пробелы
     * @param int $tags Параметр обработки тэгов
     *                     0 - не обрабатывать (по умолчанию)
     *                     1 - обрабатывать
     *                     2 - вырезать тэги
     *
     * @return string
     */
	 public static function checkout($str, $br = 0, $tags = 0){
		$str = htmlentities(trim($str), ENT_QUOTES, 'UTF-8');
		if ($br == 1){
			// Вставляем переносы строк
			$str = nl2br($str);
		}elseif ($br == 2){
			$str = str_replace("\r\n", ' ', $str);
		}
		if ($tags == 1){
			$str = ESBBCode::tags($str);
		}elseif ($tags == 2){
			$str = ESBBCode::notags($str);
		}
		return trim($str);
	}

	//Показ различных счетчиков внизу страницы
	public static function display_counters(){
		global $sys;
		$req = mysql_query("SELECT * FROM `cms_counters` WHERE `switch` = '1' ORDER BY `sort` ASC");
		if (mysql_num_rows($req) > 0){
			while (($res = mysql_fetch_array($req)) !== FALSE){
				$link1 = ($res['mode'] == 1 || $res['mode'] == 2) ? $res['link1'] : $res['link2'];
				$link2 = $res['mode'] == 2 ? $res['link1'] : $res['link2'];
				$count = ($sys['root'] == 1) ? $link1 : $link2;
				if (!empty($count))
					echo $count;
			}
		}
	}

	// Отображение различных меню
	public static function display_menu($val = array(), $delimiter = ' | ', $end_space = ''){
		return implode($delimiter, array_diff($val, array(''))).$end_space;
	}

	// Постраничная навигация
	public static function display_pages($url, $start, $total, $pages){
		$neighbors = 2;
		if ($start >= $total)
			$start = max(0, $total - (($total % $pages) == 0 ? $pages : ($total % $pages)));
		else
			$start = max(0, (int)$start - ((int)$start % (int)$pages));
		$base_link = '<span class="page1"><a href="'.strtr($url, array('%' => '%%')).'page=%d'.'">%s</a></span>';
		$out[] = $start == 0 ? '' : sprintf($base_link, $start / $pages, '&laquo;');
		if ($start > $pages * $neighbors)
			$out[] = sprintf($base_link, 1, '1');
		if ($start > $pages * ($neighbors + 1))
			$out[] = '<span class="page1">...</span>';
		for ($nCont = $neighbors; $nCont >= 1; $nCont--)
			if ($start >= $pages * $nCont){
				$tmpStart = $start - $pages * $nCont;
				$out[] = sprintf($base_link, $tmpStart / $pages + 1, $tmpStart / $pages + 1);
			}
		$out[] = '<span class="page2"><b>'.($start / $pages + 1).'</b></span>';
		$tmpMaxPages = (int)(($total - 1) / $pages) * $pages;
		for ($nCont = 1; $nCont <= $neighbors; $nCont++)
			if ($start + $pages * $nCont <= $tmpMaxPages){
				$tmpStart = $start + $pages * $nCont;
				$out[] = sprintf($base_link, $tmpStart / $pages + 1, $tmpStart / $pages + 1);
			}
		if ($start + $pages * ($neighbors + 1) < $tmpMaxPages)
			$out[] = '<span class="page1">...</span>';
		if ($start + $pages * $neighbors < $tmpMaxPages)
			$out[] = sprintf($base_link, $tmpMaxPages / $pages + 1, $tmpMaxPages / $pages + 1);
		if ($start + $pages < $total){
			$display_page = ($start + $pages) > $total ? $total : ($start / $pages + 2);
			$out[] = sprintf($base_link, $display_page, '&raquo;');
		}
		return implode(' ', $out);
	}

	// Отображения личных данных пользователя
	public static function display_user($user = 0, $arg = array()){
		global $mod;
		$out = FALSE;
		$out = '<img src="'.self::$set['home'].'/images/user.png" alt="" /> ';
		$rank = array(
			0 => '',
			1 => '.GM',
			2 => '.ADM'
		);
		$out .= (self::$user_rights ? ($user['id'] ? '<a href="'.self::$set['home'].'/users/profile.php?user='.$user['id'].'"><div class="on">'.$user['name'].$rank[$user['rights']].'</div></a>' : '<b>'.$user['name'].'</b>') : '<b>'.$user['name'].$rank[$user['rights']].'</b>');
		if (!empty($arg['header']))
			$out .= ' '.$arg['header'];
		if (isset($arg['body']))
			$out .= '<div>'.$arg['body'].'</div>';
		if (isset($arg['sub']))
			$out .= '<div>'.$arg['sub'].'</div>';
		$ipinf = !isset($arg['iphide']) && self::$user_rights ? 1 : 0;
		$lastvisit = time() > $user['lastdate'] + 300 && isset($arg['lastvisit']) ? self::display_date($user['lastdate']) : FALSE;
	/*	if ($ipinf || $lastvisit || isset($arg['sub']) && !empty($arg['sub']) || isset($arg['footer'])){
			$out .= '<div class="sub">';
			if ($lastvisit){
				$out .= '<div><span class="gray">Последний визит:</span> '.$lastvisit.'</div>';
			}
			$iphist = '';
			if ($ipinf){
				$out .= '<div><span class="gray">Браузер:</span> '.htmlspecialchars($user['browser']).'</div><div><span class="gray">Адрес IP:</span> ';
				$hist = $mod == 'history' ? '&amp;mod=history' : '';
				$ip = long2ip($user['ip']);
				if (self::$user_rights && isset($user['ip_via_proxy']) && $user['ip_via_proxy']){
					$out .= '<b class="red"><a href="'.self::$set['home'].'/xpanel/index.php?act=search_ip&amp;ip='.$ip.$hist.'">'.$ip.'</a></b>';
					$out .= '&#160;[<a href="'.self::$set['home'].'/xpanel/index.php?act=ip_whois&amp;ip='.$ip.'">?</a>]';
					$out .= ' / ';
					$out .= '<a href="'.self::$set['home'].'/xpanel/index.php?act=search_ip&amp;ip='.long2ip($user['ip_via_proxy']).$hist.'">'.long2ip($user['ip_via_proxy']).'</a>';
					$out .= '&#160;[<a href="'.self::$system_set['homeurl'].'/xpanel/index.php?act=ip_whois&amp;ip='.long2ip($user['ip_via_proxy']).'">?</a>]';
				}elseif (self::$user_rights){
					$out .= '<a href="'.self::$set['home'].'/xpanel/index.php?act=search_ip&amp;ip='.$ip.$hist.'">'.$ip.'</a>';
                    $out .= '&#160;[<a href="'.self::$set['home'].'/xpanel/index.php?act=ip_whois&amp;ip='.$ip.'">?</a>]';
				}else{
					$out .= $ip.$iphist;
				}
				$out .= '</div>';
			}
			if (isset($arg['footer']))
				$out .= $arg['footer'];
			$out .= '</div>';
		}*/
		return $out;
	}


    /**
     * Получаем данные пользователя
     *
     * @param int $id Идентификатор пользователя
     *
     * @return array|bool
     */
    public static function get_user($id = 0)
    {
        if ($id && $id != self::$user_id) {
            $req = mysql_query("SELECT * FROM `users` WHERE `id` = '$id'");
            if (mysql_num_rows($req)) {
                return mysql_fetch_assoc($req);
            } else {
                return FALSE;
            }
        } else {
            return self::$user_data;
        }
    }

    public static function image($name, $args = array())
    {
        if (is_file(ROOTPATH . 'themes' . DIRECTORY_SEPARATOR . ES::$user_set['skin'] . DIRECTORY_SEPARATOR . 'images' . DIRECTORY_SEPARATOR . $name)) {
            $src = ES::$system_set['home'] . '/themes/' . ES::$user_set['skin'] . '/images/' . $name;
        } elseif (is_file(ROOTPATH . 'images' . DIRECTORY_SEPARATOR . $name)) {
            $src = ES::$system_set['home'] . '/images/' . $name;
        } else {
            return false;
        }

        return '<img src="' . $src . '" alt="' . (isset($args['alt']) ? $args['alt'] : '') . '"' .
        (isset($args['width']) ? ' width="' . $args['width'] . '"' : '') .
        (isset($args['height']) ? ' height="' . $args['height'] . '"' : '') .
        ' class="' . (isset($args['class']) ? $args['class'] : 'icon') . '"/>';
    }


    /*
    -----------------------------------------------------------------
    Транслитерация с Русского в латиницу
    -----------------------------------------------------------------
    */
    public static function rus_lat($str)
    {
        $replace = array(
            'а' => 'a',
            'б' => 'b',
            'в' => 'v',
            'г' => 'g',
            'д' => 'd',
            'е' => 'e',
            'ё' => 'e',
            'ж' => 'j',
            'з' => 'z',
            'и' => 'i',
            'й' => 'i',
            'к' => 'k',
            'л' => 'l',
            'м' => 'm',
            'н' => 'n',
            'о' => 'o',
            'п' => 'p',
            'р' => 'r',
            'с' => 's',
            'т' => 't',
            'у' => 'u',
            'ф' => 'f',
            'х' => 'h',
            'ц' => 'c',
            'ч' => 'ch',
            'ш' => 'sh',
            'щ' => 'sch',
            'ъ' => "",
            'ы' => 'y',
            'ь' => "",
            'э' => 'ye',
            'ю' => 'yu',
            'я' => 'ya'
        );

        return strtr($str, $replace);
    }

	// Обработка смайлов
	public static function smileys($str){
		static $smileys_cache = array();
		if (empty($smileys_cache)){
			$file = ROOT.'files/cache/smileys.dat';
			if (file_exists($file) && ($smileys = file_get_contents($file)) !== FALSE){
				$smileys_cache = unserialize($smileys);
				return strtr($str, $smileys_cache['usr']);
			}else{
				return $str;
			}
		}else{
			return strtr($str, $smileys_cache['usr']);
		}
	}

    /*
    -----------------------------------------------------------------
    Функция пересчета на дни, или часы
    -----------------------------------------------------------------
    */
    public static function timecount($var)
    {
        global $lng;
        if ($var < 0) $var = 0;
        $day = ceil($var / 86400);
        if ($var > 345600) return $day . ' дней';
        if ($var >= 172800) return $day . ' дня';
        if ($var >= 86400) return '1 день';

        return date("G:i:s", mktime(0, 0, $var));
    }

    /*
    -----------------------------------------------------------------
    Транслитерация текста
    -----------------------------------------------------------------
    */
    public static function trans($str)
    {
        $replace = array(
            'a' => 'а',
            'b' => 'б',
            'v' => 'в',
            'g' => 'г',
            'd' => 'д',
            'e' => 'е',
            'yo' => 'ё',
            'zh' => 'ж',
            'z' => 'з',
            'i' => 'и',
            'j' => 'й',
            'k' => 'к',
            'l' => 'л',
            'm' => 'м',
            'n' => 'н',
            'o' => 'о',
            'p' => 'п',
            'r' => 'р',
            's' => 'с',
            't' => 'т',
            'u' => 'у',
            'f' => 'ф',
            'h' => 'х',
            'c' => 'ц',
            'ch' => 'ч',
            'w' => 'ш',
            'sh' => 'щ',
            'q' => 'ъ',
            'y' => 'ы',
            'x' => 'э',
            'yu' => 'ю',
            'ya' => 'я',
            'A' => 'А',
            'B' => 'Б',
            'V' => 'В',
            'G' => 'Г',
            'D' => 'Д',
            'E' => 'Е',
            'YO' => 'Ё',
            'ZH' => 'Ж',
            'Z' => 'З',
            'I' => 'И',
            'J' => 'Й',
            'K' => 'К',
            'L' => 'Л',
            'M' => 'М',
            'N' => 'Н',
            'O' => 'О',
            'P' => 'П',
            'R' => 'Р',
            'S' => 'С',
            'T' => 'Т',
            'U' => 'У',
            'F' => 'Ф',
            'H' => 'Х',
            'C' => 'Ц',
            'CH' => 'Ч',
            'W' => 'Ш',
            'SH' => 'Щ',
            'Q' => 'Ъ',
            'Y' => 'Ы',
            'X' => 'Э',
            'YU' => 'Ю',
            'YA' => 'Я'
        );

        return strtr($str, $replace);
    }

	public static function replacecode($search, $text){
		$search = str_replace('*', '', $search);
		return mb_strlen($search) < 3 ? $text : preg_replace('|('.preg_quote($search, '/').')|siu', '<span style="background-color:#FFFF33">$1</span>', $text);
	}
}