<?php
defined('_IN_esCMS') or die('Error: Restricted access');

@ini_set('session.use_trans_sid', '0');
@ini_set('arg_separator.output', '&amp;');
date_default_timezone_set('UTC');
mb_internal_encoding('UTF-8');

// Корневая папка
define('ROOT', dirname(dirname(__FILE__)) . DIRECTORY_SEPARATOR);

// Автозагрузка Классов
spl_autoload_register('autoload');
function autoload($name)
{
	$file = ROOT.'system/classes/'.$name.'.class.php';
	if (file_exists($file))
		require_once($file);
}
// Инициализируем Ядро системы
new ES;

// Получаем системные переменные для совместимости со старыми модулями
$ip = ES::$ip;                                        // Адрес IP
$agn = ES::$user_agent;                               // User Agent
$is_mobile = ES::$is_mobile;                          // Определение мобильного браузера

// Получаем пользовательские переменные
$user_id = ES::$user_id;                                // Идентификатор пользователя
$rights = ES::$user_rights;                             // Права доступа
$user_data = ES::$user_data;                            // Все данные пользователя
$set_user = ES::$user_set;                              // Пользовательские настройки
//$ban = ES::$user_ban;                                   // Бан
$nick = isset($user_data['nick']) ? $user_data['nick'] : false;
$pages = ES::$set['pages'] > 4 && ES::$set['pages'] < 100 ? ES::$set['pages'] : 10;

function validate_referer(){
	if ($_SERVER['REQUEST_METHOD'] !== 'POST') return;
	if (@!empty($_SERVER['HTTP_REFERER'])){
		$ref = parse_url(@$_SERVER['HTTP_REFERER']);
		if ($_SERVER['HTTP_HOST'] === $ref['host']) return;
	}
	die('Invalid request');
}
if ($rights){validate_referer();}

// Получаем и фильтруем основные переменные для системы
$id = isset($_REQUEST['id']) ? abs(intval($_REQUEST['id'])) : false;
$user = isset($_REQUEST['user']) ? abs(intval($_REQUEST['user'])) : false;
$act = isset($_REQUEST['act']) ? trim($_REQUEST['act']) : '';
$mod = isset($_REQUEST['mod']) ? trim($_REQUEST['mod']) : '';
$asc = isset($_REQUEST['asc']) ? trim($_REQUEST['asc']) : '';
$do = isset($_REQUEST['do']) ? trim($_REQUEST['do']) : false;
$page = isset($_REQUEST['page']) && $_REQUEST['page'] > 0 ? intval($_REQUEST['page']) : 1;
$start = isset($_REQUEST['page']) ? $page * $pages - $pages : (isset($_GET['start']) ? abs(intval($_GET['start'])) : 0);
$sys['root'] = isset($sys['root']) ? $sys['root'] : '';

// Закрытие сайта / редирект гостей на страницу ожидания
if ((ES::$set['site_access'] == 0 || ES::$set['site_access'] == 1) && $sys['root'] != 1 && !ES::$user_id)
{
	header('Location: '.ES::$set['home']);
}

// Буфферизация вывода
if (ES::$set['gzip'] && @extension_loaded('zlib'))
{
	@ini_set('zlib.output_compression_level', 3);
	ob_start('ob_gzhandler');
}
else
{
	ob_start();
}
$sys['referer'] = isset($_SERVER['HTTP_REFERER']) ? htmlspecialchars($_SERVER['HTTP_REFERER']) : ES::$set['home'];
$microtime = microtime(1);

?>